#pragma semicolon 1
#include <sourcemod>
#include <sdktools>


#define FILE_PATH "addons/sourcemod/configs/GlassWar.cfg"
#define TAG "[\x0BGlass War\x01]"

float StartAdvertTime;

int i_BuyZone = 0;
int i_BombSite = 0;
int i_FoGController = 0;
int i_GlassHealth = 0;

public Plugin:myinfo =
{
    name = "GlassWar plugin",
    author = "ESK0",
    description = "GlassWar plugin for CS:GO",
    version = "0.1",
};

public OnPluginStart()
{
  RegConsoleCmd("sm_gmenu", EventCMD_GMenu);
  RegAdminCmd("sm_reloadconfig", EventCMD_ReloadConfig, ADMFLAG_ROOT);
  HookEvent("round_start", Event_OnRoundStart);
}
public OnMapStart()
{
  StartAdvertTime = GetGameTime();
  LoadConfig();
}
public OnGameFrame()
{
	float time = 90.0;
	float timeleftadvert = StartAdvertTime - GetGameTime() + time;
	if(timeleftadvert < 0.01)
	{
		StartAdvertTime = GetGameTime();
		int rand = GetRandomInt(1,2);
		switch(rand)
		{
			case 1: PrintToChatAll("%s \x08On this server is running on \x0FGlassWar plugin",TAG);
			case 2:	PrintToChatAll("%s \x08For help type \x0F!gmenu",TAG);
		}
	}
}
public Action Event_OnRoundStart(Handle event, const char[] name, bool dontbroadcast)
{
  if(!i_BombSite)
  {
    int index = -1;
    while ((index = FindEntityByClassname(index, "func_bomb_target")) != -1)
    {
      if(IsValidEntity(index))
      {
        AcceptEntityInput(index, "Disable");
      }
    }
  }
  if(!i_BuyZone)
  {
    int index = -1;
    while ((index = FindEntityByClassname(index, "func_buyzone")) != -1)
    {
      if(IsValidEntity(index))
      {
        AcceptEntityInput(index, "Disable");
      }
    }
  }
  if(!i_FoGController)
  {
    int index = -1;
    while ((index = FindEntityByClassname(index, "env_fog_controller")) != -1)
    {
      if(IsValidEntity(index))
      {
        AcceptEntityInput(index, "Kill");
      }
    }
  }
  if(i_GlassHealth)
  {
    char buffer[256];
    int index = -1;
    while ((index = FindEntityByClassname(index, "func_breakable")) != -1)
    {
      if(IsValidEntity(index))
      {
        GetEntPropString(index, Prop_Data, "m_iName", buffer, sizeof(buffer));
        if(strcmp(buffer, "glass_window") == 0)
        {
          int rand = GetRandomInt(0,100);
          SetEntProp(index ,Prop_Data,"m_iHealth", rand);
        }
      }
    }
  }
}
public Action EventCMD_ReloadConfig(int client, int args)
{
  if(IsValidClient(client))
  {
      LoadConfig();
  }
}
public Action EventCMD_GMenu(int client, int args)
{
  char buffer[512];
  if(IsValidClient(client))
  {
    Menu GMenu = CreateMenu(h_GMenu);
    Format(buffer, sizeof(buffer), "--- Glass War ---");
    if(i_BuyZone) Format(buffer,sizeof(buffer), "%s\n BuyZone - Enabled",buffer);
    else Format(buffer,sizeof(buffer), "%s\n BuyZone - Disabled",buffer);

    if(i_BombSite) Format(buffer,sizeof(buffer), "%s\n Bomb - Enabled",buffer);
    else Format(buffer,sizeof(buffer), "%s\n Bomb - Disabled",buffer);

    if(i_GlassHealth) Format(buffer,sizeof(buffer), "%s\n Random glass health - Enabled",buffer);
    else Format(buffer,sizeof(buffer), "%s\n Random glass health - Disabled",buffer);

    if(i_FoGController) Format(buffer,sizeof(buffer), "%s\n Fog Controller - Enabled\n",buffer);
    else Format(buffer,sizeof(buffer), "%s\n Fog Controller - Disabled\n",buffer);
    GMenu.SetTitle(buffer);
    GMenu.AddItem("exit","Close");
    GMenu.ExitButton = false;
    GMenu.Display(client, MENU_TIME_FOREVER);
  }
  return Plugin_Handled;
}
public h_GMenu(Handle GMenu, MenuAction action, client, Position)
{
  if(action == MenuAction_Select)
  {
    char Item[20];
    GetMenuItem(GMenu, Position, Item, sizeof(Item));
  }
}
public LoadConfig()
{
  Handle hConfig = CreateKeyValues("GlassWar");
  if(!FileExists(FILE_PATH))
  {
    SetFailState("[GlassWar] 'addons/sourcemod/configs/GlassWar.cfg' not found!");
    return;
  }
  FileToKeyValues(hConfig, FILE_PATH);
  if(KvJumpToKey(hConfig, "Settings"))
  {
    i_BuyZone = KvGetNum(hConfig, "BuyZone", 1);
    i_BombSite = KvGetNum(hConfig, "BombSite", 1);
    i_FoGController = KvGetNum(hConfig, "Fog_Controller", 1);
    i_GlassHealth = KvGetNum(hConfig, "RandomGlassHealth", 1);
  }
  else
  {
    SetFailState("Config for 'Glass War' not found!");
    return;
  }
  CloseHandle(hConfig);
}

stock bool IsValidClient(client, bool alive = false)
{
	if(client >= 1 &&
		client <= MaxClients &&
		IsClientConnected(client) &&
		IsClientInGame(client) &&
		(alive == false || IsPlayerAlive(client)))
		{
			return true;
		}
	return false;
}
